; Assemble with nasm <http://www.nasm.us/>
bits 32
StackCountStorage: equ 0x42C645
push ebp
mov ebp,0xDEADBEEF
; ---------------------------------------------------------
; Changing anything above here will require modification
; of the Lua script.
push eax
push ecx
push esi
push edi
mov ebx,[ebp]
cmp ebx,1
je SpawnObject
cmp ebx,2
je CallFunction
done:
mov [ebp],ebx
pop edi
pop esi
pop ecx
pop eax
pop ebp
; The following instructions are from SA2's main code, and
; need to be here since the jump to this code replaces them
; in their original location.
push ecx
push ebx
push ebp
push esi
push edi
; ---------------------------------------------------------
mov ebx,0x77E785
jmp ebx

SpawnObject:
mov edi,[ebp+0x04]
mov eax,[ebp+0x08]
mov ecx,[ebp+0x0D]
push dword [ebp+0x0C]
mov ebx,0x46F610 ;LoadObject2
call ebx
add esp,4
mov [ebp+0x04],eax
mov esi,eax

; At this point, esi points to the ObjectMaster structure
; Now we'll allocate memory for and fill the SETEntry structure
mov eax,0x20
call AllocMem
mov dword [eax],0
mov dword [eax+0x04],0
mov ebx,[ebp+0x11]
mov [eax+0x08],ebx
mov ebx,[ebp+0x15]
mov [eax+0x0C],ebx
mov ebx,[ebp+0x19]
mov [eax+0x10],ebx
mov dword [eax+0x15],0
mov dword [eax+0x19],0
mov dword [eax+0x1D],0
mov ecx,eax

; And then allocate the structure to go at OM+0x30
mov eax,0x10
call AllocMem
mov byte [eax],1
mov byte [eax+0x01],0
mov word [eax+0x02],0x8001
mov [eax+0x04],esi
mov [eax+0x08],ecx
mov dword [eax+0x0C],0
mov [esi+0x30],eax

; Fill structure pointed to by 0x34 if present
mov edi,[esi+0x34]
test edi,edi
jz done
add edi,0x08
lea esi,[ebp+0x11]
mov ecx,9
FillStructLoop:
mov ebx,[esi]
mov [edi],ebx
add esi,4
add edi,4
loop FillStructLoop
xor ebx,ebx
not ebx ;ebx = 0xFFFFFFFF
jmp done

CallFunction:
push edx
push ebp
lea esi,[ebp+0x21]
xor ecx,ecx
mov byte cl,[ebp+0x20]
mov edi,StackCountStorage
mov [edi],ecx
test ecx,ecx
jz AfterPushLoop:
CallFunctionPushLoop:
push dword [esi]
add esi,4
loop CallFunctionPushLoop
AfterPushLoop:
mov eax,[ebp+0x08]
mov ebx,[ebp+0x0C]
mov ecx,[ebp+0x10]
mov edx,[ebp+0x14]
mov esi,[ebp+0x18]
mov edi,[ebp+0x1C]
mov ebp,[ebp+0x04]
call ebp
mov edi,StackCountStorage
mov eax,[edi]
mov edx,4
mul edx
add esp,eax
pop ebp
pop edx
xor ebx,ebx
jmp done

AllocMem:
push ecx
push ebx
mov ebx,[0x1D19CAC]
mov ecx,[ebx]
push 0
push 0x8B9528
push eax
call ecx
add esp,12
pop ebx
pop ecx
ret
